"""
Contains Fedora class
"""

from project import Project
from shared import CSC_MIRROR
import requests
from datetime import datetime
import time

class Fedora(Project):
	"""Fedora class"""

	@staticmethod
	def check(data, project, current_time):
		csc_url = CSC_MIRROR + data[project]["csc"] + data[project]["file"]
		upstream_url = data[project]["upstream"] + data[project]["file"]

		req = requests.get(csc_url)
		req.raise_for_status()
		CSC = req.text

		req = requests.get(upstream_url)
		req.raise_for_status()
		upstream = req.text

		if upstream == CSC:
			return True

        # Date example: Fedora-Rawhide-20220725.n.1
		date_format = "%Y%m%d"

		CSC_date = datetime.strptime(CSC[15:23], "%Y%m%d")
		CSC_utc_time = time.mktime(CSC_date.timetuple())

		upstream_date = datetime.strptime(upstream[15:23], "%Y%m%d")
		upstream_utc_time = time.mktime(upstream_date.timetuple())

		try:
			return upstream_utc_time - CSC_utc_time < data[project]["out_of_sync_interval"]
		except ValueError:
			return False
