"""
Contains GentooDistfiles class
"""

from project import Project
from shared import CSC_MIRROR
import requests
from datetime import datetime
import time

class GentooDistfiles(Project):
	"""GentooDistfiles class"""

	@staticmethod
	def check(data, project, current_time):
		csc_url = CSC_MIRROR + data[project]["csc"] + data[project]["file"]
		upstream_url = data[project]["upstream"] + data[project]["file"]

		req = requests.get(csc_url)
		req.raise_for_status()
		CSC = req.text

		req = requests.get(upstream_url)
		req.raise_for_status()
		upstream = req.text

		if upstream == CSC:
			return True

		CSC_utc_time = CSC[0:11]

		upstream_utc_time = upstream[0:11]

		try:
			return int(upstream_utc_time) - int(CSC_utc_time) < data[project]["out_of_sync_interval"]
		except ValueError:
			return False
