"""
Contains nongnu class
"""

from project import Project
from shared import CSC_MIRROR
import requests
from datetime import datetime
import time

class nongnu(Project):
	"""nongnu class"""

	@staticmethod
	def check(data, project, current_time):
		csc_url = CSC_MIRROR + data[project]["csc"] + data[project]["file"]
		upstream_url = data[project]["upstream"] + data[project]["file"]

		req = requests.get(csc_url)
		req.raise_for_status()
		CSC = req.text

		req = requests.get(upstream_url)
		req.raise_for_status()
		upstream = req.text

		if upstream == CSC:
			return True

		try:
			return int(upstream.partition('\n')[0]) - int(CSC.partition('\n')[0]) < data[project]["out_of_sync_interval"]
		except ValueError:
			return False
